'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var onekijsCore = require('onekijs-core');
var React = require('react');
var React__default = _interopDefault(React);
var Router$1 = require('next/router');
var Router$1__default = _interopDefault(Router$1);
var NextLink = _interopDefault(require('next/link'));

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      return function () {
        if (i >= o.length) return {
          done: true
        };
        return {
          done: false,
          value: o[i++]
        };
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  it = o[Symbol.iterator]();
  return it.next.bind(it);
}

var Link = function Link(_ref) {
  var href = _ref.href,
      replace = _ref.replace,
      scroll = _ref.scroll,
      prefetch = _ref.prefetch,
      locale = _ref.locale,
      shallow = _ref.shallow,
      children = _ref.children,
      anchorProps = _objectWithoutPropertiesLoose(_ref, ["href", "replace", "scroll", "prefetch", "locale", "shallow", "children", "Component", "isActive", "activeClassName", "activeStyle"]);

  var location = onekijsCore.useLocation();
  var settings = onekijsCore.useSettings();
  var i18n = onekijsCore.useI18n();
  var nextLocation = onekijsCore.toI18nLocation(href, settings, i18n, locale);

  if (nextLocation.baseurl !== location.baseurl) {
    return React__default.createElement("a", Object.assign({}, anchorProps, {
      href: onekijsCore.toUrl(nextLocation)
    }), children);
  }

  return React__default.createElement(NextLink, {
    href: onekijsCore.toRelativeUrl(nextLocation),
    replace: replace,
    scroll: scroll,
    prefetch: prefetch,
    locale: false,
    shallow: shallow,
    passHref: true
  }, React__default.createElement("a", Object.assign({}, anchorProps), children));
};

Link.displayName = 'Link';

var NextRouter = /*#__PURE__*/function (_AppRouter) {
  _inheritsLoose(NextRouter, _AppRouter);

  function NextRouter(listeners) {
    var _this;

    _this = _AppRouter.call(this) || this;
    _this.listeners = listeners;
    return _this;
  }

  var _proto = NextRouter.prototype;

  _proto.back = function back(delta) {
    if (delta === void 0) {
      delta = 1;
    }

    if (typeof window !== 'undefined') {
      window.history.go(-delta);
    }
  };

  _proto.forward = function forward(delta) {
    if (delta === void 0) {
      delta = 1;
    }

    if (typeof window !== 'undefined') {
      window.history.go(delta);
    }
  } // deleteOrigin() {
  //   localStorage.removeItem('onekijs.from');
  //   // localStorage.removeItem('onekijs.from_route');
  // }
  // getOrigin() {
  //   const from = localStorage.getItem('onekijs.from') || get(this.settings, 'routes.home', '/');
  //   // const fromRoute = localStorage.getItem('onekijs.from_route') || get(this.settings, 'routes.home_route', from);
  //   return { from };
  // }

  /**
   * url can be a string or an object.
   * If object, the format is the following
   * {
   *   url: string, // example: /users/1?test=1&test2#h=3&h2
   *   route: string, // example: /users/[id]
   *   pathname: string, // example: /users/1
   *   query: obj, // example: {test:1,test2:null}
   *   hash: obj // example: {h:3, h2:null}
   *   state: obj // example: {key1: 'value1'}
   * }
   */
  ;

  _proto.push = function push(urlOrLocation, options) {
    if (options === void 0) {
      options = {};
    }

    this["goto"]('push', urlOrLocation, options);
  };

  _proto.replace = function replace(urlOrLocation, options) {
    if (options === void 0) {
      options = {};
    }

    this["goto"]('replace', urlOrLocation, options);
  }
  /**
   * callback(url) where url is:
   * {
   *   url: string, // example: /users/1?test=1&test2#h=3&h2
   *   route: string, // example: /users/[id]
   *   pathname: string, // example: /users/1
   *   query: obj, // example: {test:1,test2:null}
   *   hash: obj // example: {h:3, h2:null}
   *   state: obj // example: {key1: 'value1'}
   * }
   */
  // listen(callback) {
  //   const handler = (url) => {
  //     callback(this._toLocation(url));
  //   };
  //   Router.events.on('routeChangeComplete', handler);
  //   Router.events.on('hashChangeComplete', handler);
  //   return handler;
  // }
  ;

  _proto.listen = function listen(callback) {
    var _this2 = this;

    this.listeners.push(callback);
    return function () {
      _this2.listeners.splice(_this2.listeners.indexOf(callback), 1);
    };
  };

  _proto.onLocationChange = function onLocationChange() {
    var _this3 = this;

    this.listeners.forEach(function (listener) {
      listener(_this3.location, {
        settings: _this3.settings,
        i18n: _this3.i18n
      });
    });
  } // saveOrigin(force = true) {
  //   const currentValue = localStorage.getItem('onekijs.from');
  //   if (!force && currentValue) return;
  //   let from = get(this.settings, 'routes.home', '/');
  //   let fromRoute = get(this.settings, 'routes.home_route', from);
  //   const previous = this.previousLocation;
  //   if (previous) {
  //     from = previous.relativeurl;
  //     fromRoute = previous.route || from;
  //   }
  //   localStorage.setItem('onekijs.from', from);
  //   localStorage.setItem('onekijs.from_route', fromRoute);
  // }
  ;

  _proto.sync = function sync(nextRouter) {
    var asPath = nextRouter.asPath;
    var location = onekijsCore.toI18nLocation(asPath, this.settings, this.i18n, undefined);
    this.route = nextRouter.route;
    this.params = nextRouter.query || {};

    this._pushLocation(location);
  };

  _proto.getLinkComponent = function getLinkComponent(props) {
    return React__default.createElement(Link, Object.assign({}, props));
  } // i18nLink(props, i18n, settings) {
  //   const { href, as } = props;
  //   let location;
  //   if (as) {
  //     location = toI18nLocation(as, { i18n, settings }, href);
  //   } else {
  //     location = toI18nLocation(href, { i18n, settings });
  //   }
  //   const i18nAs = toRelativeUrl(location);
  //   const i18nHref = location.route || toRelativeUrl(location);
  //   return <Link {...props} as={i18nAs} href={i18nHref} />;
  // }
  ;

  _proto["goto"] = function goto(type, urlOrLocation, options) {
    // const location = toI18nLocation(urlOrLocation, {
    //   settings: this.settings,
    //   i18n: this.i18n,
    // });
    var nextLocation = onekijsCore.toI18nLocation(urlOrLocation, this.settings, this.i18n, options == null ? void 0 : options.locale); // check if hostname is different.
    // If it's the case, use window.location and not next router

    if (nextLocation && this.location && nextLocation.baseurl !== this.location.baseurl) {
      var nextUrl = onekijsCore.toUrl(nextLocation);
      type === 'push' ? window.location.assign(nextUrl) : window.location.replace(nextUrl);
    } else if (Router$1__default.router) {
      var _nextUrl = onekijsCore.toRouteUrl(nextLocation);

      type === 'push' ? Router$1__default.router.push(_nextUrl, undefined, {
        locale: options == null ? void 0 : options.locale
      }) : Router$1__default.router.replace(_nextUrl, undefined, {
        locale: options == null ? void 0 : options.locale
      });
    }
  };

  _createClass(NextRouter, [{
    key: "native",
    get: function get() {
      return Router$1__default.router;
    }
  }]);

  return NextRouter;
}(onekijsCore.AppRouter);

var useNextRouter = Router$1.useRouter || function () {
  return null;
};

var useRouterSync = function useRouterSync(onekiRouter) {
  var nextRouter = useNextRouter();
  onekiRouter.sync(nextRouter);
  React.useEffect(function () {
    onekiRouter.onLocationChange();
  }, [nextRouter, onekiRouter]);
};

var Router = function Router(_ref) {
  var router = _ref.router,
      children = _ref.children;
  useRouterSync(router);
  return React__default.createElement(React__default.Fragment, null, children);
};

var App = function App(_ref2) {
  var _ref2$LoadingComponen = _ref2.LoadingComponent,
      LoadingComponent = _ref2$LoadingComponen === void 0 ? onekijsCore.DefaultLoadingComponent : _ref2$LoadingComponen,
      Component = _ref2.Component,
      pageProps = _ref2.pageProps,
      initialLocale = _ref2.initialLocale,
      translations = _ref2.translations,
      i18nNs = _ref2.i18nNs,
      nextRouter = _ref2.router,
      appProps = _objectWithoutPropertiesLoose(_ref2, ["LoadingComponent", "Component", "pageProps", "initialLocale", "translations", "i18nNs", "router"]);

  var routerRef = onekijsCore.useLazyRef(function () {
    return new NextRouter([]);
  }); // useEffect(() => {
  //   if (pageProps.is404) {
  //     routerRef.current.replace(toLocation(window.location.href), {
  //       shallow: true,
  //     });
  //   }
  // }, [routerRef, pageProps.is404]);

  i18nNs = React.useMemo(function () {
    return Object.keys(pageProps.translations || {}).concat(Object.keys(translations || {})).concat(i18nNs || []);
  }, [pageProps.translations, translations, i18nNs]);
  translations = React.useMemo(function () {
    return onekijsCore.simpleMergeDeep(Object.assign({}, pageProps.translations), translations);
  }, [pageProps.translations, translations]);
  initialLocale = React.useMemo(function () {
    if (nextRouter.locale) return nextRouter.locale;
    return initialLocale;
  }, [nextRouter, initialLocale]); // if (nextRouter.route === '/404') {
  //   if (route || !routerRef.location) return null;
  //   return <Error code={404} />;
  // }

  var getLayout = Component && Component.getLayout || function (page) {
    return page;
  };

  return React__default.createElement(onekijsCore.AppState, Object.assign({}, appProps, {
    initialLocale: initialLocale,
    translations: translations,
    i18nNs: i18nNs,
    LoadingComponent: LoadingComponent,
    router: routerRef.current
  }), React__default.createElement(Router, {
    router: routerRef.current
  }, getLayout(React__default.createElement(Component, Object.assign({}, pageProps)))));
  /*return (
      <Provider store={appStore}>
        <AppProvider
          router={routerRef}
          settings={formattedSettings}
          initialLocale={initialLocale}
          translations={translations}
          i18nNs={i18nNs}
          services={services}
        >
          {getLayout(<Component {...pageProps}></Component>)}
        </AppProvider>
      </Provider>
    );*/
}; // App.displayName = 'App';

/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
var getAllFiles = function getAllFiles(fs, path, basePath, relativePath, arrayOfFiles) {
  if (arrayOfFiles === void 0) {
    arrayOfFiles = [];
  }

  var dirPath = path.join(basePath, relativePath);
  var files = fs.readdirSync(dirPath);

  for (var _iterator = _createForOfIteratorHelperLoose(files), _step; !(_step = _iterator()).done;) {
    var file = _step.value;

    if (fs.statSync(dirPath + '/' + file).isDirectory()) {
      arrayOfFiles = getAllFiles(fs, path, basePath, relativePath + '/' + file, arrayOfFiles);
    } else {
      if (file !== '_app.js' && file !== '_document.js' && file !== '404.js' && file !== '_error.js') {
        var data = fs.readFileSync(dirPath + '/' + file, 'utf8');

        if (!data.includes('getStaticProps')) {
          file = file.slice(0, -3);

          if (file === 'index') {
            arrayOfFiles.push(relativePath);
            arrayOfFiles.push(relativePath + '/');
          } else {
            arrayOfFiles.push(relativePath + '/' + file);
          }
        }
      }
    }
  }

  return arrayOfFiles;
};
var get404StaticProps = function get404StaticProps(fs, path) {
  // eslint-disable-next-line
  var routes = getAllFiles(fs, path, path.join(process.cwd(), '/src/pages'), '');
  return {
    props: {
      routes: routes
    }
  };
};

Object.keys(onekijsCore).forEach(function (k) {
  if (k !== 'default') Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () {
      return onekijsCore[k];
    }
  });
});
exports.App = App;
exports.NextRouter = NextRouter;
exports.get404StaticProps = get404StaticProps;
//# sourceMappingURL=onekijs-next.cjs.development.js.map
